Attribute VB_Name = "Q4Misc"
'*************************************************************************
'*  WCL Library for Visual Basic (tm) Applications
'*************************************************************************
'(C) Copyright Multi Soft, Inc. 1992-1996. All rights reserved.
'*************************************************************************
' contents:
'    Globals, Constants, Key codes and Error codes
'*************************************************************************

'*********************************************************
'****** A P P L I C A T I O N   S T R U C T U R E S  *****
'*********************************************************

   Type FORM_PROPERTIES
        qftype            As Integer     ' 0=3270 1=HPO 2=Other
        QFLoadform        As Integer     ' should form be loaded
        qfUnloadform      As Integer     ' should form be unloaded
        QFFormName        As String * 12 ' form name <> match id (value)
        qfGetmap          As Integer     ' If True - Retrieve presentation space data
        qfPreaction       As Integer     ' If True - Invoke preaction proc
        qfDisplayaction   As Integer     ' If True - Invoke Display Action
        qfDisplaymsg      As String * 80 ' If QFDisplayAction is Message
        QFDisplayStyle    As Integer     ' Format of message form -ie icon etc
        QFPostAction      As Integer     ' If True - Invoke postaction proc
        qfPut             As Integer     ' If True - Put Fields to presentation space
        qfSendaidkey      As Integer     ' If True - Send Aidkey
        qfAidkey          As Integer     ' Aidkey value
        qfWaitcriteria    As Integer     ' Wait criteria for screen arrival
        qfTimeout         As Integer     ' New Screen Arrival Timeout
        qfRow             As Integer     ' Screen Row if Confirm is To/From Cursor
        qfCol             As Integer     ' Screen Column if Confirm is To/From Cursor
        qfScandata        As String * 32 ' Data to be matched on if WaitCriteria is CONFIRM
        QFSendData        As String * 80 ' Data is to be sent
        qfNextaction      As Integer     ' Next action type
        qfPreproc   As String * 32       ' Name of Procedure to be invoked if PREACTION is True
        QFPostProc  As String * 32       ' Name of Procedure to be invoked if POSTACTION is True
        qfNextproc  As String * 32       ' Name of Next Action Procedure or Function Text if any
   End Type

   Global FormProps As FORM_PROPERTIES

'*********************************************************

   Type App_Properties
        OpenComm          As Integer       ' should we open communication and allocate
        AppSession        As String * 1    ' session letter or blank for any available session
        FillOption        As Integer       ' 16 -nullfill 32-blankfill       available session
        waittype          As Integer       ' x_ind,from Cursor ,To cursor    available session
        Position          As Integer       ' 1 relative cursor position for wait type
        row               As Integer
        col               As Integer
        timeout           As Integer       ' default timeout
        ConvSize          As Integer       ' conversation buffer size
        MatchList         As String        ' was * 8 for short names ' Primary Match list name
        InitialActionProc As String * 32   ' Pre Matchlist Initialization
        StartAction       As Integer       ' Starting action setting
        StartActionProc   As String * 32   ' Starting proc if Action is proc
        ExitActionProc    As String * 32   ' Termination Procedure
        defaultaction     As Integer       ' No Match Action
        DefaultActionProc As String * 32   ' If No Match Action is a proc
        ErrorProc         As String * 32   ' Proc to be invoked if error detected
        ReplOption        As Integer       ' PS Input Replacement Option (blanks to nulls;nulls to blanks;underscores to blanks)  hbm 6-10-94
        ChkMapAction      As Integer       ' Screen Integrity Failure Action
        ChkMapProc        As String * 32   ' Screen Integrity Procedure       hbm 2-9-95
        HideWindow        As Integer       ' Emulator Hide
        GenButton         As Integer       ' Generate Buttons on GUI Form
        colformbg         As Integer
        collabfg          As Integer
        coltxtfg          As Integer
        coltxtbg          As Integer
        collabhifg        As Integer
        coltxthifg        As Integer
        coltxthibg        As Integer
        LabCase           As Integer
        ButtPatt1         As Integer
        ButtPatt2         As Integer
        ButtPatt3         As Integer
        ButtLine          As String * 2
        MaxButts          As Integer
   End Type

   Global AppParms  As App_Properties

'*********************************************************

   Type fontstuff
        lblname As String
        size As Currency
        lblsize As Integer
        txtname As String
        Width As Integer
        Height As Integer
        txtheight As Currency
   End Type

   Global fonttext(5) As fontstuff       'linda 4-4-96

'*********************************************************

   Global gsession As Integer       ' for the current session handle
   Global greterr As Integer        ' for all wcl return codes
   Global gps As String * 3608      ' for presentation space
   #If Win32 Then
       Global ghvb As Long    'handle to MatchList for 32-bit
       Global maphandle  As Long
   #Else
       Global ghvb As Integer 'handle to MatchList for 16-bit
       Global maphandle  As Integer
   #End If
   Global gmatchform As String * 8  ' matched form name
   Global glpmap As Long            ' for structure use
   Global gwinstate As Integer

   Global QFPath As String          ' for prefixing matchlist and any other search form files
   Global QFAppName As String       ' global to contain appname
   Global qfdebug As Integer        ' for user debugging send keys
   Global qfmatchopt As Integer     ' variable to hold option for match list process
   Global gqfmapopt As Integer      ' variable to hold option for getmaptag
   Global QFErrSw As Integer        ' switch to start error log
   Global ver As Version_Info       ' version info structure
   Global fieldinfo As field_info   ' field info structure

   Global gQFIndex           As Integer    ' index of Form /Function
   Global gUserNextAction    As Integer    ' Action Override
   Global gDefaultAction     As Integer    ' Action On Unmatched token
   Global gCommActive        As Integer    ' True If there is a Live Connection
   Global gUserFunction      As String * 32

   Global gQFAction As Integer      ' driver action
   Global gmdl As Integer           ' indicates the status of a modeless form
   Global grootdir As String        ' product installation directory
   Global gmodlen As Integer
   Global gmodcols As Integer

   Global gvernum As String
   Global memo_sw As Integer
   Global gmdbname As String
   Global ghelpfilename As String
   Global ghelpset As Integer
   Global gscrhelpname As String * 12
   Global gapp As String
   Global gdgname As String * 8
   Global prod_name As String * 8
   Global gdefault As Integer
   Global defaultsize As Integer
   Global gdelay As Integer
   Global gaction As Integer
   Global gmemoname As String
   Global gunder As Integer               'hbm 5-7-96
   Global gdgpfile As String              'hbm 5-15-96
   Global gadv As Integer
   Global gtool As Integer                'hbm 5-20-96
   Global gsetfont As Integer
   Global gveryfirsttime As Integer       'hbm 6-3-96
   Global PFKeySelected As Integer
   Global gactive As Integer
   Global guiloaded As Integer
   Global gstartscan As Integer
   Global gdelete As Integer
   Global gkeywait As Integer        ' switch to keep from putting data on non host aidkey
   Global dcrlf As String
   Global tlbls As String * 4
   Global ttxts As String * 4
   Global ttxth As Integer

   Global gemulhwnd As Integer       ' emulator handle
   Global gcrlf As String            ' all purpose carriage return/line feed

   Global mapcount As Integer
   Global mapindex As Integer
   Global txtcnt%
   Global lblcnt%
   Global cursorfld As Integer
   Global Nofields%
   Global lastrow%, lastcol%
   Global tempstr As String
   Global gfirst As Integer
   Global tabi As Integer

   Global gwkkey As String * 13
   Global gcoord As String * 4
   Global glabkey As String * 12    'hbm 2-27-96 label help setting
   Global resizing As Integer
   Global gheight As Integer
   Global gwidth As Integer
   Global btop As Integer
   Global bleft As Integer
   Global gcurlevel As Integer
   Global gmaxbutts As Integer
   Global ButtNames() As String * 4

   Global nkeys As Integer
   Global hrow As Integer
   Global hcol As Integer
   Global kval As Integer
   Global nlevels As Integer
   Global ktype As String * 2
   Global skey As String
   Global slen As Integer
   Global gindex As Integer
   Global tindex As Integer
   Global hindex As Integer
   Global hmouse As Integer
   Global htext As String * 1920
   Global gclip As Integer
   Global txtst As Integer
   Global txtlen As Integer

   Global QFMsgTxt As String
   Global QFMsgTitle As String
   Global QFMsgStyle As Integer


'*********************************************************
'************ G L O B A L    C O N S T A N T S ***********
'*********************************************************
   Global Const SETFUNC = 1
   Global Const QUERYFUNC = 2
   Global Const SET_STATUS = 1
   Global Const QUERY_STATUS = 2

   Global Const EM_SETREADONLY = &H41F      'to allow dynamic labels to be protected

   Global Const SW_NORMAL = 1
   Global Const HWND_TOPMOST = -1
   Global Const HWND_NOTOPMOST = -2
   Global Const SWP_NOSIZE = 1
   Global Const SWP_NOMOVE = 2
   Global Const Flags = SWP_NOMOVE Or SWP_NOSIZE
   Global Const No_Integrity_Chk = 0
   Global Const Integrity_Proc = 4
   Global Const Integrity_Emul = 3
   Global Const Integrity_GenForm = 7
   Global Const AUTO_FILL = &H10            '  0001 0000
   Global Const EMULWIN_HIDE = 0     ' hides the emulator window
   Global Const EMULWIN_NORMAL = 1   ' resizes the emulator window to its original size
   Global Const EMULWIN_MINIMIZE = 2 ' minimizes the emulator window
   Global Const EMULWIN_MAXIMIZE = 3 ' maximizes the emulator window
   Global Const EMULWIN_RESTORE = 9  ' restores a hidden emulator window
   Global Const win_normal = 0
   Global Const win_minimized = 1
   Global Const win_maximized = 2
   Global Const EMUL_VISIBLE = &H8&
   Global Const EMUL_INVISIBLE = &H10&
   Global Const EMUL_ACTIVATE = &H80&
   Global Const EMUL_DEACTIVATE = &H100&
   Global Const EMUL_MINIMIZE = &H400&
   Global Const EMUL_MAXIMIZE = &H800&
   Global Const EMUL_RESTORE = &H1000&
   Global Const OFN_HIDEREADONLY = &H4&
   Global Const OFN_OVERWRITEPROMPT = &H2&
   Global Const MB_ICONEXCLAMATION = 48
   Global Const MB_DEFBUTTON1 = 0
   Global Const MB_YESNOCANCEL = 3
   Global Const IDCANCEL = 2
   Global Const IDYES = 6
   Global Const IDNO = 7
   Global Const Key_F1 = &H70
   Global Const butt_pos = 430

   ' Global Quick Front Display Actions
   Global Const QFDA_FORM = 0
   Global Const QFDA_MSG = 1
   Global Const QFDA_NODISP = 2
   Global Const QFDA_FORM_MODELESS = 3    'hbm 10-21-93

   ' Global Match Result
   Global Const WCLNOMATCH = 0

   ' User   Actions
   Global Const FRMACTION = 1
   Global Const USER_OVERRIDE = 2

   Global Const WCL_STEP_MODE = &H80

   Rem **************************
   Rem  Status and Option Values:
   Rem **************************

   Global Const WA_PROTECTED = 1
   Global Const WA_UNPROTECTED = 2
   Global Const WA_NUMERIC = 4
   Global Const WA_ALPHA = 8
   Global Const WA_DISPLAY = 16
   Global Const WA_INVISIBLE = 32
   Global Const WA_BRIGHT = 64
   Global Const WA_LOWINTENSITY = 128
   Global Const WA_MODIFIED = 256
   Global Const NO_OPTIONS = 0
   Global Const ESO_ACTIVE = 1

   Rem ***************
   Rem  Trace Options:
   Rem ***************

   Global Const TRACE_ON = 1
   Global Const TRACE_OFF = 2

   Rem ******************
   Rem  Allocate Options:
   Rem ******************

   Global Const ALLOC_BY_SHORT_NAME = 1
   Global Const ALLOC_BY_LONG_NAME = 2
   Global Const ALLOC_ANY_AVAILABLE = 0

   Rem ******************
   Rem  Emulation Option:
   Rem ******************

   Global Const STEP_MODE = &H80

   Rem **************************
   Rem Global Quick Front Actions
   Rem **************************

   Global Const QFA_MATCH = 0
   Global Const QFA_EMULATION = 3
   Global Const QFA_EXIT_ENGINE = 1
   Global Const QFA_EXIT_APP = 2
   Global Const QFA_FUNCTION = 4
   Global Const QFA_OPENCONV = 5
   Global Const QFA_NEXTTRAN = 6
   Global Const QFA_GUIFORM = 7

   Rem **************
   Rem  Send Options:
   Rem **************

   Global Const PS_WAIT = 1
   Global Const PS_NOWAIT = 0
   Global Const PS_RESET = 2

   Rem *****************
   Rem  Confirm Options:
   Rem *****************

   Global Const CONFIRM_TOKEN = 1
   Global Const CONFIRM_ARRIVAL = 0    ' SAME AS TWAIT

   Rem ************************
   Rem  Get & Put Data Options:
   Rem ************************

   Global Const RETURN_ATTRIBUTES = 0       '  0000 0000   get
   Global Const TRUNCATE_AT_ATTRIB = 1      '  0000 0001   put & get
   Global Const SKIP_OVER_ATTRIB = 2        '  0000 0010   put
   Global Const REPLACE_ATTRIBUTES = 8      '  0000 1000   get
   Global Const UNDRSCR_TO_NULLS = &H4      '  0000 0100   getfield only
   Global Const BLANKS_TO_NULLS = &H10      '  0001 0000   get
   Global Const NULLS_TO_BLANKS = &H20      '  0010 0000   get
   Global Const NO_PS_CHECK = &H40          '  0100 0000   get & put/data & field
   Global Const IF_MODIFIED = &H100         '1 0000 0000   put field/ put data
   Global Const SET_ENABLED = &H80          '  1000 0000   get
   Global Const BY_POSITION = &H200        '10 0000 0000   get

   Rem *******************
   Rem  Put FIELD Options:
   Rem *******************

   Global Const NULL_FILL = &H10            '  0001 0000
   Global Const BLANK_FILL = &H20           '  0010 0000
   Global Const USE_FILL = &H200           '10 0000 0000
   Global Const TAB_TO_NEXT = 4             '  0000 0100

   Rem ***********************
   Rem  Check Map Options
   Rem ***********************

   Global Const CHECK_ALL_FIELDS = 1
   Global Const CHECK_MAP_OUT_ONLY = 2

   Rem ***********************
   Rem  Mapin, Mapout Options:
   Rem ***********************

   Global Const NULL_DELIMITED = 8          ' 0000 1000

   Rem ***************************
   Rem  Scan and Matching Options:
   Rem ***************************

   Global Const IGNORE_CASE = 1             '  0000 0001
   Global Const NULLS_AS_BLANKS = 2         '  0000 0010
   Global Const SCAN_ALL = &H10             '  0001 0000   scan extended
   Global Const MATCH_FIRST = &H20          '  0010 0000   "
   Global Const MATCH_ALL = &H40            '  0100 0000   "
   Global Const FIND_ABSOLUTE = 4           '  0000 0100   "

   Rem *******************
   Rem  MatchList Options:
   Rem *******************

   Global Const WITH_MAPS = 1
   Global Const WITH_FORMS = 2
   Global Const WITH_PROCS = 3

   Rem ******************
   Rem  Ps Status Values:
   Rem ******************

   Global Const CHANGED_PS = 1
   Global Const CHANGED_OIA = 2
   Global Const CHANGED_BOTH = 3

   Rem ************
   Rem  Wait Types:
   Rem ************

   'Wait Conditions - App Properties Constants
   Global Const WAIT_XIND = 0
   Global Const WAIT_FROM_CURSOR = 1
   Global Const WAIT_TO_CURSOR = 2

   'Wait Conditions - Form Buttons
   Global Const WC_DEFAULT = 0   ' default use app parms
   Global Const WC_XIND = 1      ' X-ind
   Global Const WC_FROMCSR = 2   ' from cursor  (cursor pos in waitparm)
   Global Const WC_TOCSR = 3     ' to cursor    (cursor pos in waitparm)

   Rem *********************
   Rem  Conversation Status:
   Rem *********************

   Global Const CV_HOST_ENDED = &H40
   Global Const CV_ERROR = &H80
   Global Const CV_RECV_PENDING = &H10
   Global Const CV_RECEIVING = &H11
   Global Const CV_SENDING = &H21
   Global Const CV_READY = &H0

   Rem *****************************************
   Rem  Conversation Options - Putdata, Getdata:
   Rem *****************************************

   Global Const CV_RESET = &H1

   Rem *****************
   Rem  Options on Send:
   Rem *****************

   Global Const CV_BINARY = &H4
   Global Const CV_CRC = &H8

   Rem **************************
   Rem  Close, Dellocate Options:
   Rem **************************

   Global Const Force = 1              ' 0000 0001

   Rem ***********************************
   Rem  Defines for Type of WCL_Translate:
   Rem ***********************************

   Global Const ASCII_TO_EBCDIC = &H0   '  18-Dec-1992 db
   Global Const EBCDIC_TO_ASCII = &H1   '  18-Dec-1992 db

   Rem ************************************************
   Rem  Defines for checking if Host Screen has changed
   Rem ************************************************

   Global Const SAMESCREEN = 0          '  12-19-94
   Global Const DIFFSCREEN = 1          '  12-19-94

   Rem ************************************
   Rem  WCLQFG_BuildForm Option (Tool only)
   Rem ************************************

   Global Const NO_MAPPING = 1
   Global Const WITH_MAPPING = 2        '  10-19-95

   Rem **********************************
   Rem  Values Returned in Session Query:
   Rem **********************************

   Rem  CLASS:

   Global Const HLAPI = 1

   Rem  TYPE:

   Global Const DFTSESSION = 2

   Rem  MODEL:

   Global Const MODEL2 = 1920   '24 x 80
   Global Const MODEL3 = 2560   '32 x 80
   Global Const MODEL4 = 3440   '43 x 80
   Global Const MODEL5 = 3564   '27 x 132

   Rem  STATUS:

   Global Const SESSIONAVAILABLE = 0
   Global Const SESSION_AVAILABLE = 0
   Global Const SESSION_ALLOCATED = 1
   Global Const SESSION_ESO = 2
   Global Const SESSION_EMULATION = 4

   Rem *************************************
   Rem  CommType - Returned in Version Info:
   Rem *************************************

   Global Const HLLAPI_IBM_PCS = 1
   Global Const HLLAPI_IRMA = 2
   Global Const HLLAPI_RUMBA = 3
   Global Const HLLAPI_RABBIT = 4
   Global Const HLLAPI_EXTRA = 5
   Global Const HLLAPI_EICON = 6
   Global Const HLLAPI_NSA = 7
   Global Const HLLAPI_ICOT = 8

   Rem ******************************
   Rem  Valid Key Codes for PsSendkey
   Rem ******************************

   Global Const WK_NOKEY = 0
   Global Const WK_ATTN = 2
   Global Const WK_BKSPC = 3
   Global Const WK_BKTAB = 4
   Global Const WK_CLEAR = 6
   Global Const WK_CLICK = 7
   Global Const WK_CRSEL = 8
   Global Const WK_DEL = 9
   Global Const WK_DOWN = 10
   Global Const WK_DUP = 11
   Global Const WK_DVCAN = 12
   Global Const WK_ENTER = 13
   Global Const WK_EREOF = 14
   Global Const WK_ERINP = 15
   Global Const WK_EXIT_KEY = 16
   Global Const WK_FM = 17
   Global Const WK_HOME = 18
   Global Const WK_IDENT = 19
   Global Const WK_INS = 20
   Global Const WK_LEFTKEY = 21
   Global Const WK_MLT = 22
   Global Const WK_NXTLN = 23
   Global Const WK_PA1 = 24
   Global Const WK_PA2 = 25
   Global Const WK_PA3 = 26
   Global Const WK_PF1 = 27
   Global Const WK_PF10 = 28
   Global Const WK_PF11 = 29
   Global Const WK_PF12 = 30
   Global Const WK_PF13 = 31
   Global Const WK_PF14 = 32
   Global Const WK_PF15 = 33
   Global Const WK_PF16 = 34
   Global Const WK_PF17 = 35
   Global Const WK_PF18 = 36
   Global Const WK_PF19 = 37
   Global Const WK_PF2 = 38
   Global Const WK_PF20 = 39
   Global Const WK_PF21 = 40
   Global Const WK_PF22 = 41
   Global Const WK_PF23 = 42
   Global Const WK_PF24 = 43
   Global Const WK_PF3 = 44
   Global Const WK_PF4 = 45
   Global Const WK_PF5 = 46
   Global Const WK_PF6 = 47
   Global Const WK_PF7 = 48
   Global Const WK_PF8 = 49
   Global Const WK_PF9 = 50
   Global Const WK_PRNT = 51
   Global Const WK_RESET = 52
   Global Const WK_RGHT = 53
   Global Const WK_SYSRQ = 54
   Global Const WK_TABKEY = 55
   Global Const WK_TEST = 56
   Global Const WK_UP = 57
   Global Const WK_POWER_ONOFF = 58  ' only RABBIT 14-Jan-1993
   Global Const WK_PAGE_UP = 59    ' only 5250   10-MAR-1994
   Global Const WK_PAGE_DOWN = 60  ' only 5250   10-MAR-1994
   Global Const WK_HELP = 61       ' only 5250   07-AUG-1995
   Global Const WK_KEYDATA = 127

   Rem *******************************
   Rem * WCL Normal Completion Codes *
   Rem *******************************

   Global Const PROC_COMPLETE = 0
   Global Const INFO_PS_ARRIVED = 1
   Global Const INFO_CHECK_FAILED = 1
   Global Const INFO_PS_NOT_ARRIVED = 2
   Global Const INFO_NOT_FOUND = 3
   Global Const INFO_FOUND = 4
   Global Const INFO_UNFORMATTED = 5
   Global Const INFO_LOCKED = 6
   Global Const INFO_UNLOCKED = 7
   Global Const INFO_SYSTEM = 8
   Global Const INFO_DELIMETER = 9
   Global Const INFO_MSG_RECEIVED = 0
   Global Const INFO_MSG_READY = 0
   Global Const INFO_MSG_RECEIVING = 11
   Global Const INFO_MSG_SENDING = 12
   Global Const INFO_FIELD_UNCHANGED = 13
   Global Const INFO_FILE_EXISTS = 50
   Global Const INFO_FILE_FOUND = 51
   Global Const INFO_FILE_NOT_FOUND = 52
   Global Const INFO_ONLY_1_FIELD = 53
   Global Const INFO_ZERO_LEN_FIELD = 54
   Global Const INFO_KEY_INTERCEPTED = 55
   Global Const INFO_NO_KEY_INTERCEPTED = 56

   Rem* ************************************** *
   Rem*        WCL Error Return Codes          *
   Rem* ************************************** *

   '* Errors Used in WCL & WCLRAB *
   Global Const ERR_COMM_DRIVER_ERROR = -101
   Global Const ERR_MEMORY_ALLOCATION_FAILED = -109
   Global Const ERR_NO_OPEN = -110
   Global Const ERR_COMM_LIBRARY_NOT_FOUND = -111
   Global Const ERR_PROC_NOT_IN_LIBRARY = -113
   Global Const ERR_INIT_SESSIONTABLE = -114
   Global Const ERR_SESSION_NOT_AVAIL = -115
   Global Const ERR_LONGNAME_NOT_FOUND = -116
   Global Const ERR_SHORTNAME_NOT_FOUND = -117
   Global Const ERR_INVALID_HANDLE = -118
   Global Const ERR_INVALID_OWNER = -119
   Global Const ERR_SESSION_NOT_ALLOCATED = -120
   Global Const ERR_INVALID_PSINDEX = -121
   Global Const ERR_INVALID_ROW_COL = -122
   Global Const ERR_TOO_MANY_TASKS = -123
   Global Const ERR_INVALID_TASK = -124
   Global Const ERR_NOTASK_WINDOW = -125
   Global Const ERR_INV_ALLOCATION_TYPE = -126
   Global Const ERR_INVALID_CLASS = -127
   Global Const ERR_INVALID_POSITION = -129
   Global Const ERR_INVALID_OPTION = -130
   Global Const ERR_PROTECTED = -131
   Global Const ERR_INVALID_LENGTH = -132
   Global Const ERR_KEYBOARD_LOCKED = -133
   Global Const ERR_INVALID_KEY = -134
   Global Const ERR_TOO_MANY_SESSIONS = -135
   Global Const ERR_INVALID_SESSION_TYPE = -136
   Global Const ERR_TIMEOUT = -137
   Global Const ERR_TRUNCATED = -138
   Global Const ERR_MAX_KEY_RETRY = -139
   Global Const ERR_SYSTEM_LOCKED_CONDITION = -140
   Global Const ERR_EMULATOR_FAILED = -141
   Global Const ERR_EMULATOR_ACTIVE = -142
   Global Const ERR_NO_OPEN_SEQ = -144
   Global Const ERR_BUFFER_OVERFLOW = -145
   Global Const ERR_BUFFER_EXHAUSTED = -146
   Global Const ERR_INVALID_REPSEQ = -147
   Global Const ERR_ISSUE_RECEIVE = -148
   Global Const ERR_INVALID_OPEN_CRC = -149
   Global Const ERR_INVALID_STATE = -150
   Global Const ERR_COMM_ABORT = -151
   Global Const ERR_CONVERSATION_ERROR = -152
   Global Const ERR_NO_TIMER_AVAIL = -153
   Global Const ERR_INVALID_ENCODE = -154
   Global Const ERR_PACKET_SEQNUM = -155
   Global Const ERR_INVALID_TAB_MOD = -156
   Global Const ERR_LOCAL_ALLOCATION_FAILED = -157
   Global Const ERR_FUNCTION_NOT_AVAILABLE = -158
   Global Const ERR_MATCHLIST_NOT_FOUND = -159
   Global Const ERR_WRITING_FILE = -160
   Global Const ERR_OPENING_FILE = -161
   Global Const ERR_INVALID_HASH = -162
   Global Const ERR_SBCS_ONLY_FIELD = -172
   Global Const ERR_DBCS_ONLY_FIELD = -173
   Global Const ERR_EMULATOR_SHUTDOWN = -174
   Global Const ERR_NO_MATCH = -402       ' from MatchList
   Global Const ERR_INVALID_SYNTAX = -401 ' from get map entry
   Global Const ERR_INVALID_INDEX = -403  ' from put/get map

   Rem* ************************************** *
   Rem*         WCL Warning Codes              *
   Rem* ************************************** *

   Global Const WARN_ALREADY_OPEN = 100
   Global Const WARN_TRUNCATED = 101
   Global Const WARN_MORE = 102
   Global Const WARN_EMPTY = 103
   Global Const WARN_XFER_INCOMPLETE = 104
   Global Const WARN_HOST_NOT_CLOSED = 105
   Global Const WARN_NO_HLL_TRACE = 106

   Rem* *************************************** *
   Rem*       WCL Extended Error Codes          *
   Rem* *************************************** *

   Rem* *************************************** *
   Rem* Low Level Routine, Extended Error Codes *
   Rem* *************************************** *

   Global Const RTN_NOROUTINE = 0
   Global Const RTN_GETPRESSPACE = 1
   Global Const RTN_GET3270STATUSLINE = 2
   Global Const RTN_PUT3270STRING = 3
   Global Const RTN_SEND3270KEY = 4
   Global Const RTN_ISKEYBOARDLOCKED = 5
   Global Const RTN_INITCOMM = 6
   Global Const RTN_GET3270CURSOR = 7
   Global Const RTN_SET3270CURSOR = 8
   Global Const RTN_SET3270PARMS = 9
   Global Const RTN_GETPSSTATUS = 10
   Global Const RTN_ALLOCATESESSION = 11
   Global Const RTN_CONNECTSESSION = 12
   Global Const RTN_DISCONNECTSESSION = 13
   Global Const RTN_ISSESSIONAVAILABLE = 14
   Global Const RTN_QUERYOIA = 15
   Global Const RTN_CLOSELLCOMM = 16
   Global Const RTN_ACTIVATE_EMU = 17
   Global Const RTN_FINDFIELD = 18
   Global Const RTN_CONNECTWINDOW = 19
   Global Const RTN_DISCONNECTWINDOW = 20
   Global Const RTN_WINDOWSTATUSEXTENDED = 21

   Rem* ************************************************************ *
   Rem            Defines for PsLockedStatus, OiaStatus              *
   Rem* ************************************************************ *

   Global Const OIA_NO_STATUS = 0
   Global Const OIA_NON_RESETABLE_MACH_CHK = 1   ' NR controller failure
   Global Const OIA_MACH_CHK = 2                 ' RESET 3 digit code
   Global Const OIA_COMM_CHK = 3                 ' RESET x-lightning bolt
   Global Const OIA_PROG_CHK = 4                 ' RESET
   Global Const OIA_DEVICE_NOT_WORKING = 5       ' DEV CANCEL- ptr not working
   Global Const OIA_DEVICE_BUSY = 6              '           - ptr busy
   Global Const OIA_TERMINAL_WAIT = 7            ' x-clock NORMAL
   Global Const OIA_MINUS_FUNC = 8               ' x-f (Sendkey tries 10 times)
   Global Const OIA_TOO_MUCH_ENTERED = 9         ' RESET stickman > (emul only)
   Global Const OIA_OPER_UNAUTH = 10             ' RESET
   Global Const OIA_OPER_UNAUTH_MINUS_FUNC = 11  ' x-f not retried by del
   Global Const OIA_INVAL_DEAD_KEY = 12          ' emulator only -
   Global Const OIA_WRONG_PLACE = 13             ' x-stk Emulator only REset
   Global Const OIA_SYSTEM_WAIT = 14             ' x-system NORMAL
   Global Const OIA_COMM_ERR_REMINDER = 15       ' lightning bolt ???
   Global Const OIA_WHAT = 16                    ' x?+ (sendkey tries 10 times)
   Global Const OIA_UNKNOWN_X = 17               ' unknown x ind, reset
   Global Const OIA_OPERATOR_INPUT_ERR = 18      ' 5250 only

   Global Const gregprefix = "SOFTWARE\MultiSoft\WCL\CurrentVersion\Comminfo\Fonts"

 '******************* temporary routines ************************
 Sub vbreplace(srcstr As String, oldstr As String, newstr As String)
 ' change all occurences of oldstr to newstr in srcstr
 ' example = vbreplace( fieldlabel,crlf,"") -- will replace
 '           Call vbreplace(f$, "WCL", "QFG")
 ' all cr/lf to nothing
     If oldstr = newstr Then Exit Sub
     Do While True
        z% = InStr(1, srcstr, oldstr)
        If z% = 0 Then Exit Do
        If z% > 1 Then
           srcstr$ = Mid(srcstr$, 1, z% - 1) + newstr + Mid(srcstr$, z% + Len(oldstr), Len(srcstr$))
           z% = z% + Len(newstr)
        Else
           srcstr$ = newstr + Mid(srcstr$, z% + Len(oldstr), Len(srcstr$))
        End If
     Loop
End Sub




